// -*- C++ -*-
/***************************************************************************
                          global.h  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GLOBAL_H
#define GLOBAL_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


enum server_states { 
  BOOT_STATE,
  PRE_GAME_STATE, 
  SELECT_TOKEN_STATE, 
  RUN_GAME_STATE,
  GAME_OVER_STATE
};

enum client_states { 
  CLIENT_NO_STATE = 0,
  CLIENT_BOOT_STATE,
  CLIENT_WAITING_FOR_SERVER_REPLY_STATE,
  CLIENT_PRE_GAME_STATE,
  CLIENT_SELECT_TOKEN_STATE,
  CLIENT_WAITING_FOR_GAME_START_STATE,
  CLIENT_GAME_RUNNING_STATE,
  CLIENT_GAME_OVER_STATE
};

enum colors {
  BLACK = 0, RED, GREEN, YELLOW, BLUE, CYAN, NCOLORS
}; 


/**************************************************************************
  command access levels for client-side use; at present, they are
  only used for server commands typed at the client chatline
 **************************************************************************/
enum cmdlevel_id {    /* access levels for users to issue commands        */
  ALLOW_NONE = 0,     /* user may issue no commands at all                */
  ALLOW_INFO,         /* user may issue informational commands            */
  ALLOW_CTRL,         /* user may issue commands that affect game & users */
  ALLOW_HACK,         /* user may issue *all* commands - dangerous!       */

  ALLOW_NUM,          /* the number of levels                             */
  ALLOW_UNRECOGNIZED  /* used as a failure return code                    */
};
/*  the set command is a special case:                                    */
/*    - ALLOW_CTRL is required for SSET_TO_CLIENT options                 */
/*    - ALLOW_HACK is required for SSET_TO_SERVER options                 */

#define GAME_MIN_PLAYERS 2
#define GAME_MAX_PLAYERS 8

#define GAME_RANDSEED		0
#define GAME_STARTBUDGET	1500
#define GAME_INCOME_ON_GO	200
#define GAME_MAX_MONEY		1000000

#define GAME_N_COMCHESTS	16
#define GAME_N_CHANCES		16
#define GAME_MAX_JAILCARDS	2

#define GAME_JAIL_FINE	50

#define GAME_DEFAULT_AIFILL	2

#define FIELD_MAX_LENGTH_NAME 30
#define MONOP_MAX_LENGTH_COLOR 20

#define PROPERTY_UNMORTGAGE_FACTOR	0.1
#define STREET_MAX_HOUSES	4
#define STREET_N_RENT_CLASSES	(STREET_MAX_HOUSES + 2)

#define BOARD_N_FIELDS 40
#define BOARD_N_MONOPS 8
#define BOARD_N_RAILROADS 4
#define BOARD_N_UTILS 2

#define MAX_STREETS_IN_MONOP 3

#define PLAYER_MAX_LENGTH_NAME 32
#define PLAYER_MAX_LENGTH_ADDRESS 32

#define NOBODY	(GAME_MAX_PLAYERS+1)
#define BANK	0
#define TOALL	0

#define DEFAULT_SOCK_PORT 2525
#define DEFAULT_HOST	"localhost"

// disable this when releasing !!!
#define CHEATING_ALLOWED	1

const char *cmdlevel_name(enum cmdlevel_id lvl);
enum cmdlevel_id cmdlevel_named (char *token);


#endif  /* GLOBAL_H */
