// -*- C++ -*-
/***************************************************************************
                          shared.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SHARED_H
#define SHARED_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stddef.h>

/* Version stuff is now in version.h --dwp */

#define BUG_EMAIL_ADDRESS "hoermen@users.sourceforge.net"
#define WEBSITE_URL "http://capitalist.sourceforge.net/"

#define BROADCAST_EVENT -2

#ifndef MAX
#define MAX(x,y) (((x)>(y))?(x):(y))
#define MIN(x,y) (((x)<(y))?(x):(y))
#endif

#define WIPEBIT(val, no) ((~(-1<<no))&val)  |   ((  (-1<<(no+1)) &val) >>1)

#define MAX_UINT32 0xFFFFFFFF

#define ARRAY_SIZE(x) (sizeof(x) / sizeof((x)[0]))

typedef unsigned int RANDOM_TYPE;

const char *n_if_vowel(const char ch);
char *create_centered_string(const char *s);

char *get_option_text(char **argv, int *argcnt, int max_argcnt,
		      char short_option, char *long_option);
char *int_to_text(int nr);
char *get_sane_name(const char *name);
char *get_dot_separated_int(unsigned val);
int mystrcasecmp(const char *str0, const char *str1);
int mystrncasecmp(const char *str0, const char *str1, const int n);
int string_ptr_compare(const void *first, const void *second);

char *mystrerror(int errnum);
void myusleep(unsigned long usec);

size_t mystrlcpy(char *dest, const char *src, size_t n);
size_t mystrlcat(char *dest, const char *src, size_t n);

/* convenience macros for use when dest is a char ARRAY: */
#define sz_strlcpy(dest,src) ((void)mystrlcpy((dest),(src),sizeof(dest)))
#define sz_strlcat(dest,src) ((void)mystrlcat((dest),(src),sizeof(dest)))

int cat_snprintf(char *str, size_t n, const char *format, ...) throw();

RANDOM_TYPE myrand(int size);
void mysrand(RANDOM_TYPE seed);
void save_restore_random(void);

char *remove_leading_spaces(char *s);
void remove_trailing_spaces(char *s);
void remove_trailing_char(char *s, char trailing);
int wordwrap_string(char *s, int len);

char *user_home_dir(void);
char *datafilename(const char *filename);
char *datafilename_required(const char *filename);

#endif  /* SHARED_H */
