// -*- C++ -*-
/***************************************************************************
                          cardstack.h  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef CARDSTACK_H
#define CARDSTACK_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "field.h"

class Player;

class Cardstack {
  
public:
  
  Cardstack(int ncards);
  ~Cardstack();

  Cardstack(const Cardstack&);	// not defined!

  void shuffle();
  int draw_card();
  
  void remove(int card_no);
  void put_back(int card_no);

protected:
  
  int randseed;

  int _ncards;
  int *shuffled;
  bool *removed;

};

class JailCard {

public:

  JailCard(Cardstack *stack, int card_no)
    : _stack(stack), _card_no(card_no) {}

  ~JailCard() {}

  void put_back();

protected:

  Cardstack *_stack;
  int _card_no;

};

#endif /* CARDSTACK_H */
