// -*- C++ -*-
/***************************************************************************
                          field.cpp  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <assert.h>

#include "global.h"
#include "log.h"
#include "packets.h"
#include "events.h"

#include "game.h"

#include "field.h"

extern Game *game;

Field::Field(const int location)
  : _location(location), 
    _type(SAFEFIELD)
{
}

Field::~Field()
{
}




void Field::enter(Player *pplayer)
{
  freelog(LOG_NORMAL, "Player has entered field %d", _location);

  game->send_field_info(pplayer, this, E_ENTER_FIELD);
}


int const Field::status(const Player *) const
{
  /* all flags are unset for general fields as default */
  return 0;
}

int const Field::actions(const Player *) const
{
  /* all flags are unset for general fields as default */
  return 0;
}



void Field::init_info_for(const Player *player, 
			  struct packet_field_init_info *pack)
{
  int i;

  pack->location = _location;
  pack->type = _type;
  pack->price = 0;
  
  for (i=0; i<STREET_N_RENT_CLASSES; ++i)
    pack->rent[i] = 0;
}


void Field::info_for(const Player *player,
		     struct packet_field_info *pack, int event)
{

  // TODO: remove location
  pack->location = _location;
  pack->event = event;

  pack->statusflags = status(player);
  pack->actionflags = actions(player);

  pack->owner = NOBODY;
  pack->nhouses = 0;
}

