// -*- C++ -*-
/***************************************************************************
                          jailfield.cpp  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <assert.h>

#include "log.h"
#include "packets.h"
#include "events.h"

#include "game.h"
#include "board.h"
#include "player.h"

#include "cardstack.h"

#include "jailfield.h"

extern Game *game;


Jailfield::Jailfield(const int location)
  : Field(location)
{
  _type = JAILFIELD;
}


void Jailfield::enter(Player *plr)
{
  freelog(LOG_NORMAL, "Player has entered jail field %d", _location);
	  
  switch(_location) {

  case GOTO_JAIL:
    plr->goto_jail(E_GOTO_JAIL_ENTERED_FIELD);
    break;

  default:
    assert(0);	// bug: no other possible locations for taxes

  }

}

