// -*- C++ -*-
/***************************************************************************
                          railroad.cpp  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <assert.h>

#include "railroad.h"

Railroad::Railroad(const int location, const int price, const int rent)
  : Property(location, price),
    _rent(rent)
{
  _type = RAILROAD;
}

void Railroad::init_info_for(const Player *player, 
			     struct packet_field_init_info *pack)
{
  int i;

  pack->location = _location;
  pack->type = RAILROAD;
  pack->price = _price;
  pack->rent[0] = _rent;
  for (i=1; i<STREET_N_RENT_CLASSES; ++i)
    pack->rent[i] = 0;
}
