// -*- C++ -*-
/***************************************************************************
                          railroad.h  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef RAILROAD_H
#define RAILROAD_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>

#include "global.h"
#include "player.h"

#include "property.h"

class Railroad : public Property {
  
public:
  
  Railroad(const int location, const int price, const int rent);

  Railroad(struct packet_field_init_info *);

  const int rent() const 
    { return _rent * ((_owner!=NULL)? _owner->nrailroads() : 0 ); }

  const int base_rent() const
    { return _rent; }
  
  virtual void init_info_for(const Player *, struct packet_field_init_info *);
  
protected:

  int _rent;
  
};
  
  
#endif /* RAILROAD_H */
