// -*- C++ -*-
/***************************************************************************
                          taxfield.cpp  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <assert.h>
#include <cmath>

#include "log.h"
#include "packets.h"
#include "events.h"

#include "game.h"
#include "board.h"
#include "player.h"

#include "cardstack.h"

#include "taxfield.h"

extern Game *game;


Taxfield::Taxfield(const int location)
  : Field(location)
{
  _type = TAXFIELD;
}


void Taxfield::enter(Player *plr)
{
  freelog(LOG_NORMAL, "Player has entered tax field %d", _location);
	  
  switch(_location) {

  case INCOME_TAX:
    {
      // \todo: let the user choose between $200 and 10% of holdings
      int tax_holdings = plr->tax_holdings();
      freelog(LOG_VERBOSE, "income tax value of holdings: $%d", tax_holdings);
      int var_tax = (int) round((double)tax_holdings/10);
      if (var_tax < 200) {
	plr->pay(NULL, var_tax, E_PAY_TAX);
	freelog(LOG_VERBOSE, "pay income tax of 10% of tax value of holdings: "
		"$%d", var_tax);
      } else { // it's better to pay $200
	plr->pay(NULL, 200, E_PAY_TAX);
	freelog(LOG_VERBOSE, "pay income tax of $200");
      }
      break;
    }
  case LUXURY_TAX:
    plr->pay(NULL, 75, E_PAY_TAX);	// tax amount (75) correct ????
    break;
    
  default:
    assert(0);	// bug: no other possible locations for taxes

  }

}

