// -*- C++ -*-
/***************************************************************************
                          utility.cpp  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <assert.h>

#include "property.h"

#include "utility.h"

Utility::Utility(const int location, const int price, const int rent_factor[])
  : Property(location, price)
{
  _type = UTILITY;

  _rent_factor[0] = rent_factor[0];
  _rent_factor[1] = rent_factor[1];
}

void Utility::init_info_for(const Player *player, 
			    struct packet_field_init_info *pack)
{
  int i;

  pack->location = _location;
  pack->type = _type;
  pack->price = _price;

  pack->rent[0] = _rent_factor[0];
  pack->rent[1] = _rent_factor[1];
  for (i=2; i<STREET_N_RENT_CLASSES; ++i)
    pack->rent[i] = 0;
}
