// -*- C++ -*-
/***************************************************************************
                          utility.h  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef UTILITY_H
#define UTILITY_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>

#include "global.h"

#include "game.h"
#include "player.h"

#include "property.h"

extern Game *game;

class Utility : public Property {
  
public:
  
  Utility(const int location, const int price, const int rent_factor[]);

  Utility(struct packet_field_init_info *);

  const int rent() const 
    { 
      if (_owner!=NULL) 
	return (game->last_dice_total() * _rent_factor[_owner->nutils()-1]);
      else return 0;
    }

  const int rent_factor(int f) const
    { assert(f==0 || f==1); return _rent_factor[f]; }

  virtual void init_info_for(const Player *, struct packet_field_init_info *);
  
protected:

  int _rent_factor[2];
  
};
  
  
#endif /* UTILITY_H */
