// -*- C++ -*-
/***************************************************************************
                          gamelog.cpp  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// System
//

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

//
// Common + Handler
//

#include "log.h"
#include "mem.h"

#include "gamelog.h"


int gamelog_level;		/* also accessed from stdinhand.c */
static char *gamelog_filename;

/**************************************************************************
filename can be NULL, which means no logging.
***************************************************************************/
void gamelog_init(char *filename)
{
  gamelog_level=GAMELOG_FULL;
  gamelog_filename=filename;
}

/**************************************************************************/
void gamelog_set_level(int level)
{
  gamelog_level=level;
}

/**************************************************************************/
void gamelog(int level, char *message, ...)
{
  va_list args;
  char buf[512];
  FILE *fs;

  if (gamelog_filename==NULL)
    return;
  if (level > gamelog_level)
    return;

  fs=fopen(gamelog_filename, "a");
  if(!fs) {
    freelog(LOG_FATAL, "couldn't open gamelogfile: %s for appending.\n", 
	    gamelog_filename);
    exit(1);
  }
  
  va_start(args, message);
  vsprintf(buf, message, args);
  if (level==GAMELOG_EOT){
    fprintf(fs,"*** %s\n",buf);
  } else {
    fprintf(fs,"%s\n",buf);
  }
  fflush(fs);
  fclose(fs);
}


