// -*- C++ -*-
/***************************************************************************
                          main.h  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef MAIN_H
#define MAIN_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//
// Common + Handler
//

#include "attribute.h"

#include "global.h"
#include "packets.h"

//
// Game
//

class Player;



struct connection;

void handle_packet_input(struct connection *pconn, char *packet, int type);
void handle_request_join_game(struct connection *pconn, 
			      struct packet_req_join_game *request);

void accept_new_player(char *name, struct connection *pconn);
void lost_connection_to_player(struct connection *pconn);
void server_remove_player(Player *pplayer);
void generate_ai_players(void);

void set_server_state(enum server_states);

void send_game_state(Player *dest, int state);

/* TODO: kick out start_game (move everything in game->run() ) */
void start_game(void);


extern enum server_states server_state;

#endif /* MAIN_H */
