// -*- C++ -*-
/***************************************************************************
                          plrhand.cpp  -  description
                             -------------------
    begin                : Fre Jun 22 17:19:03 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// System
//

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

//
// Common + Handler
//

#include "events.h"
#include "log.h"
#include "mem.h"
#include "packets.h"
#include "shared.h"

#include "main.h"
#include "gamelog.h"
#include "sernet.h"
#include "plrhand.h"

//
// Game
//

#include "game.h"
#include "player.h"



extern Game *game;

/*
 * !! TODO: !! move all this to Player.cc
 */

/**************************************************************************
...
**************************************************************************/

void notify_player_ex(Player *pplayer, int x, int y, int event, char *format, ...) 
{
  int i;
  struct packet_generic_message genmsg;
  va_list args;
  va_start(args, format);
  vsprintf(genmsg.message, format, args);
  va_end(args);
  genmsg.event = event;
  for(i=0; i<game->nplayers(); i++)
    if(!pplayer || pplayer==game->player(i)) {
      if (server_state >= RUN_GAME_STATE) {
	genmsg.x = x;
	genmsg.y = y;
      } else {
	genmsg.x = 0;
	genmsg.y = 0;
      }
      send_packet_generic_message(game->player(i)->conn(), PACKET_CHAT_MSG, &genmsg);
    }
}


/**************************************************************************
...
**************************************************************************/

void notify_player(Player *pplayer, char *format, ...) 
{
  int i;
  struct packet_generic_message genmsg;
  va_list args;
  va_start(args, format);
  vsprintf(genmsg.message, format, args);
  va_end(args);
  genmsg.x = -1;
  genmsg.y = -1;
  genmsg.event = -1;
  for(i=0; i<game->nplayers(); i++)
    if(!pplayer || pplayer==game->player(i))
      send_packet_generic_message(game->player(i)->conn(), PACKET_CHAT_MSG, &genmsg);
}

/**************************************************************************
This function pops up a non-modal message dialog on the player's desktop
**************************************************************************/
void page_player(Player *pplayer, char *headline, char *lines) {
    page_player_generic(pplayer,headline,lines,-1);
}


/**************************************************************************
This function pops up a non-modal message dialog on the player's desktop
event == -1: message should not be ignored by clients watching AI players with 
             ai_popup_windows off.  Example: Server Options, Demographics 
             Report, etc.
event == BROADCAST_EVENT: message can safely be ignored by clients watching AI
                          players with ai_popup_windows off.
         For example: Herodot's report... and similar messages.
**************************************************************************/
void page_player_generic(Player *pplayer, char *headline, char *lines, int event) 
{
  int i;
  struct packet_generic_message genmsg;

  if(strlen(headline)+1+strlen(lines) >= sizeof(genmsg.message)) {
    freelog(LOG_NORMAL, "Message too long in page_player_generic!!");
    return;
  }
  strcpy(genmsg.message, headline);
  strcat(genmsg.message, "\n");
  strcat(genmsg.message, lines);
  genmsg.event = event;
  
  
  for(i=0; i<game->nplayers(); i++)
    if(!pplayer || pplayer==game->player(i))
      send_packet_generic_message(game->player(i)->conn(), PACKET_PAGE_MSG, 
				  &genmsg);
}




